## spkg-1.6.0-rc3.tar

=== requirements.txt ===
colorama
halo
requests
urllib3

=== htop/PKGBUILD ===
#!/bin/bash

name=htop
ver=git
arch=all
dep_apt="libncursesw5-dev autotools-dev autoconf automake build-essential tar"
dep_apk="gcc g++ make ncurses-dev tar automake autoconf"

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'

if ! [ -f "/usr/bin/apt" ] && ! [ -f "/sbin/apk" ]; then
    echo "This build script cannot be executed on your system. Sorry"
    exit
fi

[[ -f "/usr/bin/apt" ]] && pkg_mgr="apt"
[[ -f "/sbin/apk" ]] && pkg_mgr="apk"

if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi

get_dependencies() {
    [[ "${pkg_mgr}" == "apt" ]] && cmd="apt install -y $dep_apt"
    [[ "${pkg_mgr}" == "apk" ]] && cmd="apk add $dep_apk"

    $cmd &> /dev/null
}

extract() {
    cd /tmp/ || exit
    mv htop*.tar.gz /tmp/target.tar.gz
    mkdir /tmp/target

    tar xf /tmp/target.tar.gz --directory /tmp/target/
    cd /tmp/target/htop* || exit
}

compile() {
    ./autogen.sh && ./configure && make
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Installing dependencies ... "
    get_dependencies

    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing htop ... "
    make install
}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing htop ... "
    make install
}

remove() {
    echo -e "${Green}>>>${Reset}${Bold} Removing htop ... "
    rm -f /usr/bin/htop
    rm -f /usr/local/bin/htop
    read -rep $'\033[0;33m>>>\033[0m\e[1m Remove dependencies? [Y/N] ' ans

    if [[ "${ans}" != "y" ]] && [[ "${ans}" != "Y" ]] && [[ "${ans}" != "j" ]] && [[ "${ans}" != "j" ]]; then
        exit
    else 
        [[ "${pkg_mgr}" == "apt" ]] && cmd="apt remove -y $dep_apt"
        [[ "${pkg_mgr}" == "apk" ]] && cmd="apk remove $dep_apk"

        $cmd &> /dev/null
    fi
}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi

=== micro/PKGBUILD ===
#!/bin/bash

name=micro
ver=git
arch=all
dep_apt="make golang unzip"
dep_apk="make go unzip"

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'

if ! [ -f "/usr/bin/apt" ] && ! [ -f "/sbin/apk" ]; then
    echo "This build script cannot be executed on your system. Sorry"
    exit
fi

[[ -f "/usr/bin/apt" ]] && pkg_mgr="apt"
[[ -f "/sbin/apk" ]] && pkg_mgr="apk"

if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi

get_dependencies() {
    [[ "${pkg_mgr}" == "apt" ]] && cmd="apt install -y $dep_apt"
    [[ "${pkg_mgr}" == "apk" ]] && cmd="apk add $dep_apk"

    $cmd &> /dev/null
}

extract() {
    cd /tmp/ || exit
    mv micro-master.zip /tmp/target.zip
    mkdir /tmp/target

    unzip /tmp/target.zip -d /tmp/target/
    cd /tmp/target/micro-master/ || exit
}

compile() {
    make
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Installing dependencies ... "
    get_dependencies

    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing nano ... "
    mv /tmp/target/micro-master/micro /usr/local/bin/micro
}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing nano ... "
    mv /tmp/target/micro-master/micro /usr/local/bin/micro
}

remove() {
    echo -e "${Green}>>>${Reset}${Bold} Removing nano ... "
    rm -f /usr/local/bin/micro
    read -rep $'\033[0;33m>>>\033[0m\e[1m Remove dependencies? [Y/N] ' ans

    if [[ "${ans}" != "y" ]] && [[ "${ans}" != "Y" ]] && [[ "${ans}" != "j" ]] && [[ "${ans}" != "j" ]]; then
        exit
    else 
        [[ "${pkg_mgr}" == "apt" ]] && cmd="apt remove -y $dep_apt"
        [[ "${pkg_mgr}" == "apk" ]] && cmd="apk remove $dep_apk"

        $cmd &> /dev/null
    fi
}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi

=== nano/PKGBUILD ===
#!/bin/bash

name=nano
ver=git
arch=all
dep_apt="libncursesw5-dev autotools-dev autopoint gettext git groff pkg-config texinfo autoconf automake build-essential tar"
dep_apk="gcc g++ make ncurses-dev automake autoconf gettext git groff pkgconfig texinfo tar"

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'

if ! [ -f "/usr/bin/apt" ] && ! [ -f "/sbin/apk" ]; then
    echo "This build script cannot be executed on your system. Sorry"
    exit
fi

[[ -f "/usr/bin/apt" ]] && pkg_mgr="apt"
[[ -f "/sbin/apk" ]] && pkg_mgr="apk"

if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi

get_dependencies() {
    [[ "${pkg_mgr}" == "apt" ]] && cmd="apt install -y $dep_apt"
    [[ "${pkg_mgr}" == "apk" ]] && cmd="apk add $dep_apk"

    $cmd &> /dev/null
}

extract() {
    cd /tmp/ || exit
    mv nano*.tar.gz /tmp/target.tar.gz
    mkdir /tmp/target

    tar xf /tmp/target.tar.gz --directory /tmp/target/
    cd /tmp/target/nano* || exit
}

compile() {
    ./autogen.sh
    ./configure && make
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Installing dependencies ... "
    get_dependencies

    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing nano ... "
    make install
}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing nano ... "
    make install
}

remove() {
    echo -e "${Green}>>>${Reset}${Bold} Removing nano ... "
    rm -f /usr/local/bin/nano
    rm -f /usr/bin/nano
    read -rep $'\033[0;33m>>>\033[0m\e[1m Remove dependencies? [Y/N] ' ans

    if [[ "${ans}" != "y" ]] && [[ "${ans}" != "Y" ]] && [[ "${ans}" != "j" ]] && [[ "${ans}" != "j" ]]; then
        exit
    else 
        [[ "${pkg_mgr}" == "apt" ]] && cmd="apt remove -y $dep_apt"
        [[ "${pkg_mgr}" == "apk" ]] && cmd="apk remove $dep_apk"

        $cmd &> /dev/null
    fi
}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi

=== neofetch/PKGBUILD ===
#!/bin/bash

name=neofetch
ver=7.1.0
arch=all
dep_apt="bash"
dep_apk="bash"

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'

if ! [ -f "/usr/bin/apt" ] && ! [ -f "/sbin/apk" ]; then
    echo "This package script is official not supported for your system."
    echo "Make sure, you have installed the following dependency: bash"
fi

[[ -f "/usr/bin/apt" ]] && pkg_mgr="apt"
[[ -f "/sbin/apk" ]] && pkg_mgr="apk"

if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi

get_dependencies() {
    [[ "${pkg_mgr}" == "apt" ]] && cmd="apt install -y $dep_apt"
    [[ "${pkg_mgr}" == "apk" ]] && cmd="apk add bash $dep_apk"

    $cmd &> /dev/null
}

extract() {
    cd /tmp || exit
    mv neofetch* target.tar.gz
    mkdir /tmp/target/
    tar xf /tmp/target.tar.gz --directory /tmp/target/
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Installing dependencies ... "
    get_dependencies

    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Installing neofetch ... "
    install -Dt /usr/bin/ -m 775 /tmp/target/hyfetch*/neofetch
}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Installing neofetch ... "
    install -Dt /usr/bin/ -m 775 /tmp/target/hyfetch*/neofetch
}

remove() {
    echo -e "${Green}>>>${Reset}${Bold} Removing neofetch ... "
    rm -f /usr/bin/neofetch
}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi

=== python3.11/PKGBUILD ===
#!/bin/bash

name=python
ver=3.11
arch=all
dep_apt="wget build-essential libncursesw5-dev libssl-dev libsqlite3-dev tk-dev libgdbm-dev libc6-dev libbz2-dev libffi-dev zlib1g-dev make tar"
dep_apk="wget gcc g++ ncurses-dev libressl-dev openssl-dev sqlite-dev tk-dev gdbm-dev libc-dev libbz2 libffi-dev zlib-dev automake autoconf make tar"

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'

if ! [ -f "/usr/bin/apt" ] && ! [ -f "/sbin/apk" ]; then
    echo "This build script cannot be executed on your system. Sorry"
    exit
fi

[[ -f "/usr/bin/apt" ]] && pkg_mgr="apt"
[[ -f "/sbin/apk" ]] && pkg_mgr="apk"

if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi

get_dependencies() {
    [[ "${pkg_mgr}" == "apt" ]] && cmd="apt install -y $dep_apt"
    [[ "${pkg_mgr}" == "apk" ]] && cmd="apk add $dep_apk"

    $cmd &> /dev/null
}

extract() {
    cd /tmp/ || exit
    mv Python*.tgz /tmp/target.tgz
    mkdir /tmp/target

    tar xf /tmp/target.tgz --directory /tmp/target/
    cd /tmp/target/Python* || exit
}

configure() {
    sleep 0.5
    ./configure --enable-optimizations
}

compile() {
    make -j $(nproc)
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Installing dependencies ... "
    get_dependencies

    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Configuring ... "
    configure

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing python3.11 ... "
    make altinstall
    ln -s /usr/local/bin/python3.11 /usr/local/bin/python
}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Configuring ... "
    configure

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing python3.11 ... "
    make altinstall
    ln -s /usr/local/bin/python3.11 /usr/local/bin/python
}

remove() {
    echo -e "${Green}>>>${Reset}${Bold} Removing python3.11 ... "
    rm -rf /usr/local/bin/python3.11
    rm -rf /usr/local/lib/python3.11
    rm -rf /usr/lib/python3.11/
    read -rep $'\033[0;33m>>>\033[0m\e[1m Remove dependencies? [Y/N] ' ans

    if [[ "${ans}" != "y" ]] && [[ "${ans}" != "Y" ]] && [[ "${ans}" != "j" ]] && [[ "${ans}" != "j" ]]; then
        exit
    else 
        [[ "${pkg_mgr}" == "apt" ]] && cmd="apt remove -y $dep_apt"
        [[ "${pkg_mgr}" == "apk" ]] && cmd="apk remove $dep_apk"

        $cmd &> /dev/null
    fi
}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi

=== rtw89/PKGBUILD ===
#!/bin/bash

name=rtw89
ver=git
arch=amd64
dep_apt="make gcc linux-headers-$(uname -r) build-essential git"
dep_dnf="kernel-headers kernel-devel"
dep_zypper="make gcc kernel-devel kernel-default-devel git libopenssl-devel"

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'

if ! [ -f "/usr/bin/apt" ] && ! [ -f "/sbin/apk" ]; then
    echo "This build script cannot be executed on your system. Sorry"
    exit
fi

[[ -f "/usr/bin/apt" ]] && pkg_mgr="apt"
[[ -f "/usr/bin/dnf" ]] && pkg_mgr="dnf"
[[ -f "/usr/bin/zypper" ]] && pkg_mgr="zypper"
[[ -f "/usr/bin/pacman" ]] && pkg_mgr="pacman"

if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi

get_dependencies() {
    [[ "${pkg_mgr}" == "apt" ]] && cmd="apt install -y $dep_apt"
    [[ "${pkg_mgr}" == "dnf" ]] && cmd="dnf install $dep_dnf && dnf group install 'C Development Tools and Libraries'"
    [[ "${pkg_mgr}" == "apt" ]] && cmd="zypper install $dep_zypper"
    [[ "${pkg_mgr}" == "pacman" ]] && cmd="git clone https://aur.archlinux.org/rtw89-dkms-git.git && cd rtw89-dkms-git && makepkg -sri"

    $cmd
}

extract() {
    cd /tmp/ || exit
    mv rtw89*.tar.gz /tmp/target.tar.gz
    mkdir /tmp/target

    tar xf /tmp/target.tar.gz --directory /tmp/target/
    cd /tmp/target/rtw89* || exit
}

compile() {
    make
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Installing dependencies ... "
    get_dependencies

    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing drivers/rtw89 ... "
    make install

}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Compiling ... "
    compile

    echo -e "${Green}>>>${Reset}${Bold} Installing drivers/rtw89 ... "
    make install
}

remove() {
    echo -e "${Green}>>>${Reset}${Bold} Removing drivers/rtw89 ... "
    # read -rep $'\033[0;33m>>>\033[0m\e[1m Remove dependencies? [Y/N] ' ans

    # if [[ "${ans}" != "y" ]] && [[ "${ans}" != "Y" ]] && [[ "${ans}" != "j" ]] && [[ "${ans}" != "j" ]]; then
    #     exit
    # else 
    #     [[ "${pkg_mgr}" == "apt" ]] && cmd="apt remove -y $dep_apt"

    #     $cmd &> /dev/null
    # fi

    curl --output '/tmp/rtw89.tar.gz' --url 'https://github.com/lwfinger/rtw89/archive/refs/heads/main.tar.gz'
    extract
    sudo make uninstall

}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi

=== spkg-git/PKGBUILD ===
#!/bin/bash

name=spkg-git
ver=git
arch=all
dep_apt="python3 python3-dev python3-pip python3-sql python3-urllib3 python3-colorama python3-requests sudo"
dep_apk="python3 py3-pip py3-colorama py3-requests sudo zstd"
dep_pip="colorama halo requests"

Reset='\033[0m'
Bold="\e[1m"
Green='\033[0;32m'

if ! [ -f "/usr/bin/apt" ] && ! [ -f "/sbin/apk" ]; then
    echo "This package script is official not supported for your system."
    echo "Make sure, you have installed the following dependencies: python3 python3-dev python3-pip python3-sql python3-urllib3 sudo"
fi

[[ -f "/usr/bin/apt" ]] && pkg_mgr="apt"
[[ -f "/sbin/apk" ]] && pkg_mgr="apk"

if (( $(id -u) != 0 )); then
    echo "This package script can only be run with root (permisson denied)"
    exit
fi


get_dependencies() {
    [[ "${pkg_mgr}" == "apt" ]] && cmd="apt install -y $dep_apt"
    [[ "${pkg_mgr}" == "apk" ]] && cmd="apk add bash $dep_apk"

    $cmd &> /dev/null
    sudo -H pip install "$dep_pip" --break-system-packages
    sudo -H pip install "$dep_pip"
}

extract() {
    cd /tmp || exit
    mv spkg*.tar.gz target.tar.gz
    mkdir /tmp/target/
    tar xf /tmp/target.tar.gz --directory /tmp/target/
    cd /tmp/target/spkg* || exit
}

inst() {
    echo -e "${Green}>>>${Reset}${Bold} Installing dependencies ... "
    get_dependencies

    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Installing spkg-git ... "
    rm -f /usr/bin/spkg
    rm -rf /usr/share/spkg/
    cp -r /tmp/target/spkg-main/ /usr/share/spkg/
    cp -r /tmp/target/spkg-main/data/etc/ /

    cd /usr/share/spkg/ || exit
    mv spkg.py spkg

    rm -rf build
    rm -rf data
    rm -rf resources
    rm -rf packages
    rm -f package.db
    rm -f spkg-installer.py
    rm -f requirements.txt
    rm -f rmcache.sh
    rm -f todo.txt

    chmod a+x /usr/share/spkg/spkg
    ln -s /usr/share/spkg/spkg /usr/bin/spkg

    spkg build world
    spkg sync
}

upgrade() {
    echo -e "${Green}>>>${Reset}${Bold} Extracting sources ... "
    extract

    echo -e "${Green}>>>${Reset}${Bold} Installing spkg-gitspkg-git ... "
    rm -f /usr/bin/spkg
    rm -rf /usr/share/spkg/
    cp -r /tmp/target/spkg-main/ /usr/share/spkg/

    cd /usr/share/spkg/ || exit
    mv spkg.py spkg

    rm -rf build
    rm -rf data
    rm -rf resources
    rm -rf packages
    rm -f package.db
    rm -f spkg-installer.py
    rm -f requirements.txt
    rm -f rmcache.sh
    rm -f todo.txt

    chmod a+x /usr/share/spkg/spkg
    ln -s /usr/share/spkg/spkg /usr/bin/spkg

    spkg sync
}

remove() {
    read -rep $'\033[0;33m>>>\033[0m\e[1m Are you sure? This will remove spkg from your system. [Y/N] ' ans_s
    if [[ "${ans_s}" != "y" ]] && [[ "${ans_s}" != "Y" ]] && [[ "${ans_s}" != "j" ]] && [[ "${ans_s}" != "j" ]]; then
            echo -e "Aborting"
            exit
    fi

    echo -e "${Green}>>>${Reset}${Bold} Removing spkg-git ... "

    rm -rf /usr/share/spkg
    rm -f /usr/bin/spkg
    rm -rf /etc/spkg/
    rm -f /tmp/PKGBUILD
}

clean_tmp() {
    echo -e "${Green}>>>${Reset}${Bold} Cleaning temporary files ... "
    rm -rf /tmp/target*
    rm -f /tmp/PKGBUILD
}

if [ "$1" = "--install" ]; then
    inst
    clean_tmp

elif [ "$1" = "--upgrade" ]; then
    upgrade
    clean_tmp

elif [ "$1" = "--remove" ]; then
    remove
    clean_tmp
fi
